// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=false, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "vis_QF_BV_fru32_p1.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 6 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 6);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (6 - 1);
  typedef unsigned char SORT_3;  // BV with 1 bits
  const SORT_3 mask_SORT_3 = (SORT_3)-1 >> (sizeof(SORT_3) * 8 - 1);
  const SORT_3 msb_SORT_3 = (SORT_3)1 << (1 - 1);
  typedef unsigned int SORT_6;  // BV with 32 bits
  const SORT_6 mask_SORT_6 = (SORT_6)-1 >> (sizeof(SORT_6) * 8 - 32);
  const SORT_6 msb_SORT_6 = (SORT_6)1 << (32 - 1);
  typedef unsigned char SORT_24;  // BV with 5 bits
  const SORT_24 mask_SORT_24 = (SORT_24)-1 >> (sizeof(SORT_24) * 8 - 5);
  const SORT_24 msb_SORT_24 = (SORT_24)1 << (5 - 1);
  typedef unsigned char SORT_33;  // BV with 2 bits
  const SORT_33 mask_SORT_33 = (SORT_33)-1 >> (sizeof(SORT_33) * 8 - 2);
  const SORT_33 msb_SORT_33 = (SORT_33)1 << (2 - 1);
  // Initializing constants ...
  const SORT_1 var_21 = 0;
  const SORT_24 var_26 = 31;
  const SORT_6 var_28 = 0;
  const SORT_33 var_34 = 0;
  const SORT_33 var_35 = 1;
  const SORT_3 var_37 = 1;
  const SORT_3 var_43 = 0;
  const SORT_33 var_55 = 2;
  const SORT_33 var_72 = 3;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_3 input_4;
  SORT_1 input_5;
  SORT_6 input_7;
  SORT_3 input_8;
  SORT_6 input_9;
  SORT_1 input_10;
  SORT_1 input_11;
  SORT_1 input_12;
  SORT_3 input_13;
  SORT_3 input_14;
  SORT_3 input_15;
  SORT_3 input_16;
  SORT_3 input_17;
  SORT_3 input_18;
  SORT_3 input_19;
  SORT_3 input_20;
  SORT_3 input_117;
  SORT_3 input_121;
  SORT_1 input_123;
  SORT_3 input_125;
  SORT_33 input_128;
  SORT_3 input_130;
  SORT_6 input_133;
  SORT_3 input_135;
  // Collecting state declarations ...
  SORT_1 state_22 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_6 state_29 = __VERIFIER_nondet_uint() & mask_SORT_6;
  SORT_6 state_31 = __VERIFIER_nondet_uint() & mask_SORT_6;
  SORT_1 state_39 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_3 state_44 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_3 state_48 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_1 state_57 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_3 state_61 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_3 state_65 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_1 state_74 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_3 state_78 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_3 state_82 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_3 state_86 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_6 state_95 = __VERIFIER_nondet_uint() & mask_SORT_6;
  SORT_1 state_113 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_3 state_115 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  SORT_3 state_119 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  // Initializing states ...
  SORT_1 init_23_arg_1 = var_21;
  state_22 = init_23_arg_1;
  SORT_6 init_30_arg_1 = var_28;
  state_29 = init_30_arg_1;
  SORT_6 init_32_arg_1 = var_28;
  state_31 = init_32_arg_1;
  SORT_1 init_40_arg_1 = var_21;
  state_39 = init_40_arg_1;
  SORT_3 init_45_arg_1 = var_43;
  state_44 = init_45_arg_1;
  SORT_3 init_49_arg_1 = var_43;
  state_48 = init_49_arg_1;
  SORT_1 init_58_arg_1 = var_21;
  state_57 = init_58_arg_1;
  SORT_3 init_62_arg_1 = var_43;
  state_61 = init_62_arg_1;
  SORT_3 init_66_arg_1 = var_43;
  state_65 = init_66_arg_1;
  SORT_1 init_75_arg_1 = var_21;
  state_74 = init_75_arg_1;
  SORT_3 init_79_arg_1 = var_43;
  state_78 = init_79_arg_1;
  SORT_3 init_83_arg_1 = var_43;
  state_82 = init_83_arg_1;
  SORT_3 init_87_arg_1 = var_43;
  state_86 = init_87_arg_1;
  SORT_6 init_96_arg_1 = var_28;
  state_95 = init_96_arg_1;
  SORT_1 init_114_arg_1 = var_21;
  state_113 = init_114_arg_1;
  SORT_3 init_116_arg_1 = var_43;
  state_115 = init_116_arg_1;
  SORT_3 init_120_arg_1 = var_43;
  state_119 = init_120_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_2 = input_2 & mask_SORT_1;
    input_4 = __VERIFIER_nondet_uchar();
    input_4 = input_4 & mask_SORT_3;
    input_5 = __VERIFIER_nondet_uchar();
    input_5 = input_5 & mask_SORT_1;
    input_7 = __VERIFIER_nondet_uint();
    input_7 = input_7 & mask_SORT_6;
    input_8 = __VERIFIER_nondet_uchar();
    input_8 = input_8 & mask_SORT_3;
    input_9 = __VERIFIER_nondet_uint();
    input_9 = input_9 & mask_SORT_6;
    input_10 = __VERIFIER_nondet_uchar();
    input_10 = input_10 & mask_SORT_1;
    input_11 = __VERIFIER_nondet_uchar();
    input_11 = input_11 & mask_SORT_1;
    input_12 = __VERIFIER_nondet_uchar();
    input_12 = input_12 & mask_SORT_1;
    input_13 = __VERIFIER_nondet_uchar();
    input_13 = input_13 & mask_SORT_3;
    input_14 = __VERIFIER_nondet_uchar();
    input_14 = input_14 & mask_SORT_3;
    input_15 = __VERIFIER_nondet_uchar();
    input_15 = input_15 & mask_SORT_3;
    input_16 = __VERIFIER_nondet_uchar();
    input_16 = input_16 & mask_SORT_3;
    input_17 = __VERIFIER_nondet_uchar();
    input_17 = input_17 & mask_SORT_3;
    input_18 = __VERIFIER_nondet_uchar();
    input_18 = input_18 & mask_SORT_3;
    input_19 = __VERIFIER_nondet_uchar();
    input_19 = input_19 & mask_SORT_3;
    input_20 = __VERIFIER_nondet_uchar();
    input_20 = input_20 & mask_SORT_3;
    input_117 = __VERIFIER_nondet_uchar();
    input_117 = input_117 & mask_SORT_3;
    input_121 = __VERIFIER_nondet_uchar();
    input_121 = input_121 & mask_SORT_3;
    input_123 = __VERIFIER_nondet_uchar();
    input_123 = input_123 & mask_SORT_1;
    input_125 = __VERIFIER_nondet_uchar();
    input_125 = input_125 & mask_SORT_3;
    input_128 = __VERIFIER_nondet_uchar();
    input_128 = input_128 & mask_SORT_33;
    input_130 = __VERIFIER_nondet_uchar();
    input_130 = input_130 & mask_SORT_3;
    input_133 = __VERIFIER_nondet_uint();
    input_133 = input_133 & mask_SORT_6;
    input_135 = __VERIFIER_nondet_uchar();
    input_135 = input_135 & mask_SORT_3;
    // Assuming invariants ...
    // Asserting properties ...
    SORT_1 var_25_arg_0 = state_22;
    SORT_24 var_25 = var_25_arg_0 >> 0;
    var_25 = var_25 & mask_SORT_24;
    SORT_24 var_27_arg_0 = var_25;
    SORT_24 var_27_arg_1 = var_26;
    SORT_3 var_27 = var_27_arg_0 == var_27_arg_1;
    SORT_24 var_102_arg_0 = var_25;
    SORT_24 var_102_arg_1 = var_26;
    SORT_3 var_102 = var_102_arg_0 == var_102_arg_1;
    SORT_1 var_36_arg_0 = state_22;
    SORT_3 var_36 = var_36_arg_0 >> 5;
    var_36 = var_36 & mask_SORT_3;
    SORT_3 var_73_arg_0 = var_36;
    SORT_3 var_73_arg_1 = var_37;
    SORT_3 var_73 = var_73_arg_0 == var_73_arg_1;
    SORT_1 var_76_arg_0 = state_22;
    SORT_1 var_76_arg_1 = state_74;
    SORT_3 var_76 = var_76_arg_0 == var_76_arg_1;
    SORT_3 var_77_arg_0 = var_73;
    SORT_3 var_77_arg_1 = var_76;
    SORT_3 var_77 = var_77_arg_0 & var_77_arg_1;
    var_77 = var_77 & mask_SORT_3;
    SORT_3 var_80_arg_0 = state_78;
    SORT_3 var_80_arg_1 = var_37;
    SORT_3 var_80 = var_80_arg_0 != var_80_arg_1;
    SORT_3 var_81_arg_0 = var_77;
    SORT_3 var_81_arg_1 = var_80;
    SORT_3 var_81 = var_81_arg_0 & var_81_arg_1;
    var_81 = var_81 & mask_SORT_3;
    SORT_3 var_84_arg_0 = state_82;
    SORT_3 var_84_arg_1 = var_37;
    SORT_3 var_84 = var_84_arg_0 == var_84_arg_1;
    SORT_3 var_85_arg_0 = var_81;
    SORT_3 var_85_arg_1 = var_84;
    SORT_3 var_85 = var_85_arg_0 & var_85_arg_1;
    var_85 = var_85 & mask_SORT_3;
    SORT_3 var_88_arg_0 = state_86;
    SORT_3 var_88_arg_1 = var_37;
    SORT_3 var_88 = var_88_arg_0 == var_88_arg_1;
    SORT_3 var_89_arg_0 = var_85;
    SORT_3 var_89_arg_1 = var_88;
    SORT_3 var_89 = var_89_arg_0 & var_89_arg_1;
    var_89 = var_89 & mask_SORT_3;
    SORT_24 var_90_arg_0 = var_25;
    SORT_24 var_90_arg_1 = var_26;
    SORT_3 var_90 = var_90_arg_0 != var_90_arg_1;
    SORT_3 var_91_arg_0 = var_89;
    SORT_3 var_91_arg_1 = var_90;
    SORT_3 var_91 = var_91_arg_0 & var_91_arg_1;
    var_91 = var_91 & mask_SORT_3;
    SORT_3 var_56_arg_0 = var_36;
    SORT_3 var_56_arg_1 = var_37;
    SORT_3 var_56 = var_56_arg_0 == var_56_arg_1;
    SORT_1 var_59_arg_0 = state_22;
    SORT_1 var_59_arg_1 = state_57;
    SORT_3 var_59 = var_59_arg_0 == var_59_arg_1;
    SORT_3 var_60_arg_0 = var_56;
    SORT_3 var_60_arg_1 = var_59;
    SORT_3 var_60 = var_60_arg_0 & var_60_arg_1;
    var_60 = var_60 & mask_SORT_3;
    SORT_3 var_63_arg_0 = state_61;
    SORT_3 var_63_arg_1 = var_37;
    SORT_3 var_63 = var_63_arg_0 == var_63_arg_1;
    SORT_3 var_64_arg_0 = var_60;
    SORT_3 var_64_arg_1 = var_63;
    SORT_3 var_64 = var_64_arg_0 & var_64_arg_1;
    var_64 = var_64 & mask_SORT_3;
    SORT_3 var_67_arg_0 = state_65;
    SORT_3 var_67_arg_1 = var_37;
    SORT_3 var_67 = var_67_arg_0 == var_67_arg_1;
    SORT_3 var_68_arg_0 = var_64;
    SORT_3 var_68_arg_1 = var_67;
    SORT_3 var_68 = var_68_arg_0 & var_68_arg_1;
    var_68 = var_68 & mask_SORT_3;
    SORT_24 var_69_arg_0 = var_25;
    SORT_24 var_69_arg_1 = var_26;
    SORT_3 var_69 = var_69_arg_0 != var_69_arg_1;
    SORT_3 var_70_arg_0 = var_68;
    SORT_3 var_70_arg_1 = var_69;
    SORT_3 var_70 = var_70_arg_0 & var_70_arg_1;
    var_70 = var_70 & mask_SORT_3;
    SORT_3 var_38_arg_0 = var_36;
    SORT_3 var_38_arg_1 = var_37;
    SORT_3 var_38 = var_38_arg_0 == var_38_arg_1;
    SORT_1 var_41_arg_0 = state_22;
    SORT_1 var_41_arg_1 = state_39;
    SORT_3 var_41 = var_41_arg_0 == var_41_arg_1;
    SORT_3 var_42_arg_0 = var_38;
    SORT_3 var_42_arg_1 = var_41;
    SORT_3 var_42 = var_42_arg_0 & var_42_arg_1;
    var_42 = var_42 & mask_SORT_3;
    SORT_3 var_46_arg_0 = state_44;
    SORT_3 var_46_arg_1 = var_37;
    SORT_3 var_46 = var_46_arg_0 == var_46_arg_1;
    SORT_3 var_47_arg_0 = var_42;
    SORT_3 var_47_arg_1 = var_46;
    SORT_3 var_47 = var_47_arg_0 & var_47_arg_1;
    var_47 = var_47 & mask_SORT_3;
    SORT_3 var_50_arg_0 = state_48;
    SORT_3 var_50_arg_1 = var_37;
    SORT_3 var_50 = var_50_arg_0 == var_50_arg_1;
    SORT_3 var_51_arg_0 = var_47;
    SORT_3 var_51_arg_1 = var_50;
    SORT_3 var_51 = var_51_arg_0 & var_51_arg_1;
    var_51 = var_51 & mask_SORT_3;
    SORT_24 var_52_arg_0 = var_25;
    SORT_24 var_52_arg_1 = var_26;
    SORT_3 var_52 = var_52_arg_0 != var_52_arg_1;
    SORT_3 var_53_arg_0 = var_51;
    SORT_3 var_53_arg_1 = var_52;
    SORT_3 var_53 = var_53_arg_0 & var_53_arg_1;
    var_53 = var_53 & mask_SORT_3;
    SORT_3 var_54_arg_0 = var_53;
    SORT_33 var_54_arg_1 = var_35;
    SORT_33 var_54_arg_2 = var_34;
    SORT_33 var_54 = var_54_arg_0 ? var_54_arg_1 : var_54_arg_2;
    SORT_3 var_71_arg_0 = var_70;
    SORT_33 var_71_arg_1 = var_55;
    SORT_33 var_71_arg_2 = var_54;
    SORT_33 var_71 = var_71_arg_0 ? var_71_arg_1 : var_71_arg_2;
    SORT_3 var_92_arg_0 = var_91;
    SORT_33 var_92_arg_1 = var_72;
    SORT_33 var_92_arg_2 = var_71;
    SORT_33 var_92 = var_92_arg_0 ? var_92_arg_1 : var_92_arg_2;
    SORT_33 var_99_arg_0 = var_92;
    SORT_33 var_99_arg_1 = var_35;
    SORT_3 var_99 = var_99_arg_0 == var_99_arg_1;
    SORT_33 var_97_arg_0 = var_92;
    SORT_33 var_97_arg_1 = var_34;
    SORT_3 var_97 = var_97_arg_0 == var_97_arg_1;
    SORT_3 var_100_arg_0 = var_99;
    SORT_3 var_100_arg_1 = var_97;
    SORT_3 var_100 = var_100_arg_0 | var_100_arg_1;
    var_100 = var_100 & mask_SORT_3;
    SORT_3 var_98_arg_0 = var_97;
    SORT_6 var_98_arg_1 = var_28;
    SORT_6 var_98_arg_2 = state_95;
    SORT_6 var_98 = var_98_arg_0 ? var_98_arg_1 : var_98_arg_2;
    SORT_33 var_93_arg_0 = var_92;
    SORT_33 var_93_arg_1 = var_55;
    SORT_3 var_93 = var_93_arg_0 == var_93_arg_1;
    SORT_3 var_94_arg_0 = var_93;
    SORT_6 var_94_arg_1 = state_31;
    SORT_6 var_94_arg_2 = state_29;
    SORT_6 var_94 = var_94_arg_0 ? var_94_arg_1 : var_94_arg_2;
    SORT_3 var_101_arg_0 = var_100;
    SORT_6 var_101_arg_1 = var_98;
    SORT_6 var_101_arg_2 = var_94;
    SORT_6 var_101 = var_101_arg_0 ? var_101_arg_1 : var_101_arg_2;
    SORT_3 var_103_arg_0 = var_102;
    SORT_6 var_103_arg_1 = var_28;
    SORT_6 var_103_arg_2 = var_101;
    SORT_6 var_103 = var_103_arg_0 ? var_103_arg_1 : var_103_arg_2;
    SORT_6 var_104_arg_0 = var_103;
    SORT_1 var_104 = var_104_arg_0 >> 26;
    var_104 = var_104 & mask_SORT_1;
    SORT_1 var_105_arg_0 = var_104;
    SORT_1 var_105_arg_1 = var_21;
    SORT_3 var_105 = var_105_arg_0 == var_105_arg_1;
    SORT_3 var_106_arg_0 = var_27;
    SORT_3 var_106_arg_1 = var_105;
    SORT_3 var_106 = var_106_arg_0 & var_106_arg_1;
    var_106 = var_106 & mask_SORT_3;
    SORT_3 var_107_arg_0 = var_106;
    SORT_3 var_107 = ~var_107_arg_0;
    var_107 = var_107 & mask_SORT_3;
    SORT_3 var_110_arg_0 = var_107;
    SORT_3 var_110 = ~var_110_arg_0;
    var_110 = var_110 & mask_SORT_3;
    SORT_3 var_111_arg_0 = var_37;
    SORT_3 var_111_arg_1 = var_110;
    SORT_3 var_111 = var_111_arg_0 & var_111_arg_1;
    var_111 = var_111 & mask_SORT_3;
    SORT_3 bad_112_arg_0 = var_111;
    __VERIFIER_assert(!(bad_112_arg_0));
    // Computing next states ...
    SORT_1 next_138_arg_1 = input_11;
    SORT_6 next_139_arg_1 = input_7;
    SORT_6 next_140_arg_1 = input_9;
    SORT_3 var_141_arg_0 = state_119;
    SORT_1 var_141_arg_1 = state_57;
    SORT_1 var_141_arg_2 = state_39;
    SORT_1 var_141 = var_141_arg_0 ? var_141_arg_1 : var_141_arg_2;
    SORT_1 next_142_arg_1 = var_141;
    SORT_3 next_143_arg_1 = input_19;
    SORT_3 var_144_arg_0 = state_119;
    SORT_3 var_144_arg_1 = state_61;
    SORT_3 var_144_arg_2 = state_48;
    SORT_3 var_144 = var_144_arg_0 ? var_144_arg_1 : var_144_arg_2;
    SORT_3 next_145_arg_1 = var_144;
    SORT_1 next_146_arg_1 = input_10;
    SORT_3 next_147_arg_1 = input_8;
    SORT_3 next_148_arg_1 = input_18;
    SORT_1 next_149_arg_1 = input_5;
    SORT_1 var_150_arg_0 = state_113;
    SORT_3 var_150 = var_150_arg_0 >> 5;
    var_150 = var_150 & mask_SORT_3;
    SORT_1 var_151_arg_0 = state_113;
    SORT_3 var_151 = var_151_arg_0 >> 2;
    var_151 = var_151 & mask_SORT_3;
    SORT_3 var_152_arg_0 = var_150;
    SORT_3 var_152_arg_1 = var_151;
    SORT_3 var_152 = var_152_arg_0 & var_152_arg_1;
    var_152 = var_152 & mask_SORT_3;
    SORT_1 var_153_arg_0 = state_113;
    SORT_3 var_153 = var_153_arg_0 >> 0;
    var_153 = var_153 & mask_SORT_3;
    SORT_3 var_154_arg_0 = var_153;
    SORT_3 var_154 = ~var_154_arg_0;
    var_154 = var_154 & mask_SORT_3;
    SORT_3 var_155_arg_0 = var_152;
    SORT_3 var_155_arg_1 = var_154;
    SORT_3 var_155 = var_155_arg_0 & var_155_arg_1;
    var_155 = var_155 & mask_SORT_3;
    SORT_3 var_156_arg_0 = state_115;
    SORT_3 var_156_arg_1 = var_155;
    SORT_3 var_156_arg_2 = state_78;
    SORT_3 var_156 = var_156_arg_0 ? var_156_arg_1 : var_156_arg_2;
    SORT_3 next_157_arg_1 = var_156;
    SORT_3 next_158_arg_1 = input_4;
    SORT_3 next_159_arg_1 = input_17;
    SORT_3 var_160_arg_0 = state_119;
    SORT_6 var_160_arg_1 = state_31;
    SORT_6 var_160_arg_2 = state_95;
    SORT_6 var_160 = var_160_arg_0 ? var_160_arg_1 : var_160_arg_2;
    SORT_6 next_161_arg_1 = var_160;
    SORT_1 next_162_arg_1 = input_2;
    SORT_3 next_163_arg_1 = input_14;
    SORT_3 next_164_arg_1 = input_16;
    // Assigning next states ...
    state_22 = next_138_arg_1;
    state_29 = next_139_arg_1;
    state_31 = next_140_arg_1;
    state_39 = next_142_arg_1;
    state_44 = next_143_arg_1;
    state_48 = next_145_arg_1;
    state_57 = next_146_arg_1;
    state_61 = next_147_arg_1;
    state_65 = next_148_arg_1;
    state_74 = next_149_arg_1;
    state_78 = next_157_arg_1;
    state_82 = next_158_arg_1;
    state_86 = next_159_arg_1;
    state_95 = next_161_arg_1;
    state_113 = next_162_arg_1;
    state_115 = next_163_arg_1;
    state_119 = next_164_arg_1;
  }
  return 0;
}
